#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Mar 17 17:15:22 2019

@author: gilles
"""

import math

###############
# Exercice 1 #
#############

# Méthode 1

""" Fonction quartiles(;q1, q3 : flottants)
n : entier, nombre de notes
tab : tableau de flottants contenant les n notes
rang1 ,rang3 : entiers, les rangs de Q1 et Q3
renvoie q1 et q3, les valeurs du premier et du troisième quartile"""


def quartiles():
    tab=[]
    n=int(input("Nombres de valeurs : "))
    for i in range(n):
        note=float(input("Note : "))
        tab.append(note)
    tab.sort()
    if n%4==0:     ## si le nombre de valeurs est un multiple de 4
        rang1=n//4    ## quotient dans la division euclidienne
        rang3=3*n//4
    else:        ## si le nombre de valeurs n'est pas un multiple de 4
        rang1=math.ceil(n/4)    ## pour l'arrondi par excès
        rang3=math.ceil(3*n/4)   ## division quelconque
    q1=tab[rang1-1]   ## premier quartile
    q3=tab[rang3-1]   ## troisième quartile
    return q1,q3

# Méthode 2

""" Fonction effectifTotal(tab : tableau double [flottant,entier];total : entier)
tab : tableau (valeur,effectif)
renvoie total, l'effectif total de la série"""

def effectifTotal(tab):
    total=0
    for i in range(len(tab)):
        total=total+tab[i][1]   ## les effectifs sont les deuxièmes valeurs des couples
    return total

""" Fonction indexECC(n : entier, tab : tableau double [flottant,entier]; i : entier)
tab : tableau (valeur,effectif)
n : l'effectif cumulé croissant visé
i : l'indice de la valeur courante
index : entier, l'ECC de la valeur d'indice i
renvoie total, l'effectif total de la série"""


def indexECC(n,tab):
    index=tab[0][1]
    i=0
    while index<n:
        i=i+1
        index=index+tab[i][1]
    return i


""" Fonction quartiles(tab : tableau double [flottant,entier];q1, q3 : flottants)
N : entier, nombre de notes
tab : tableau contenant les N notes
rang1 ,rang3 : entiers, les rangs de Q1 et Q3
i1, i3 : entiers, les indices des valeurs de Q1 et Q3 dans le tableau tab
renvoie q1 et q3, les valeurs du premier et du troisième quartile"""

def quartiles(tab):
    N=effectifTotal(tab)
    if N%4==0:     ## si le nombre de valeurs est un multiple de 4
        rang1=N//4    ## quotient dans la division euclidienne
        rang3=3*N//4
    else:        ## si le nombre de valeurs n'est pas un multiple de 4
        rang1=math.ceil(N/4)    ## pour l'arrondi par excès
        rang3=math.ceil(3*N/4)   ## division quelconque
    i1=ECC(rang1,tab)
    i3=ECC(rang3,tab)
    q1=tab[i1][0]   ## premier quartile
    q3=tab[i3][0]   ## troisième quartile
    return q1,q3



###############
# Exercice 2 #
#############
    

""" Fonction chiffresUn(u : chaîne;res : chaîne):
u : terme dont on veut connaître la suite des caractères
chn : chaîne, copie de u 
ln : entier, taille de chn
j : entier, rang du caractère étudié dans chn
k : entier, rang des carcactères suivant chn[j]
cpt : entier, nombre de répétitions de chn[j]
renvoie res, la chaîne constitué des caractères de chn avec leur répétition """

def chiffresUn(u):
    chn=u
    ln=len(chn)
    j=0
    res=""
    while j<ln:
        k=j+1
        cpt=1
        while k<ln and chn[k]==chn[j]:  # mettre "k<ln" en premier pour éviter d'avoir un rang hors de la chaîne
            cpt=cpt+1           # on compte le nombre d'apparition du caractère
            k=k+1
        res=res+str(cpt)+chn[j]
        j=k
    return res


""" Fonction suiteConway(n: entier;u : chaîne)
n : rang du dernier terme de la suite (u_n) définie par récurrence dans laquelle chaque terme est constitué des chiffres du précédent 
avec leur fréquence d'apparation
i : entier, rang du terme courant
renvoie u, le dernier de la suite (u_n) """

def suiteConway(n):
    u="1"
    print(u)
    for i in range(n):
        u=chiffresUn(u)
        print(u)
    return u

###############
# Exercice 3 #
##############

""" Fonction chiffreCesar(mot : chaîne; txtcode : chaîne)
mot : mot que l'on peut déchiffrer avec la méthode de César
lt : entier, nombre de caractère de texte
i : entier, rang du caractère courant dans texte
car1 : caractère, celui de rang i dans texte
rang1 : entier, rang de car1 dans l'alphabet latin
rang2 : entier, rang de car2 dans l'alphabet latin
car2 : caractère, celui de rang i dans motcode
renvoie motcode, le chiffrement de mot avec la méthode de César pour une clé quelconque """


def chiffreCesar(mot):
    lt=len(mot)
    mot=mot.lower()  # mise en minuscule
    motcode=""
    for i in range(lt):
        car1=mot[i]
        rang1=ord(car1)-97  # mise à zéro sur l'alphabet
        rang2=(rang1+3)%26+97 # calcul du rang en tenant compte du décalage
        car2=chr(rang2)  # conversion en caractère
        motcode=motcode+car2
    return motcode



""" Fonction chiffrementCesar(texte : chaîne, decalage : entier;dec : chaîne)
texte : phrase que l'on peut déchiffrer avec la méthode de César
decalage : clé de chiffrement pour la méthode de César
lt : entier, nombre de caractère de texte
i : entier, rang du caractère courant dans texte
car1 : caractère, celui de rang i dans texte
rang1 : entier, rang de car1 dans l'alphabet latin
rang2 : entier, rang de car2 dans l'alphabet latin
car2 : caractère, celui de rang i dans msgcode
renvoie msgcode, le chiffrement de texte avec la méthode de César pour une clé quelconque """
    
def chiffrementCesar(texte,decalage):
    lt=len(texte)
    texte=texte.lower()  # mise en majuscule
    msgcode=""
    for i in range(lt):
        car1=texte[i]
        if car1!=' ':
            rang1=ord(car1)-97  # mise à zéro sur l'alphabet
            rang2=(rang1+decalage)%26+97 # calcul du rang en tenant compte du décalage
            car2=chr(rang2)  # conversion en caractère
        else :
            car2=' '
        msgcode=msgcode+car2
    return msgcode

""" Fonction decryptageBrutal(texte : chaîne;)
texte : phrase que l'on veut déchiffrer avec la méthode de César
i : entier, décalage dans la méthode de César
affiche toutes les phrases déchiffrés à partir de texte, pour des décalages compris entre 0 et 25 """

def decryptageBrutal(texte):
    for i in range(26):
        print(i)
        print(chiffrementCesar(texte,-i))
        
    
###############
# Exercice 4 #
#############
        

from turtle import *
from math import sqrt,atan,degrees

""" Fonction escargotPythagore(n : entier;)
n : nombre de triangles rectangles constituant l'escargot
angle : flottant, angle au sommet commun à tous les triangles
long : entier, longueur, en pixels, du côté de longueur 1
renvoie une figure """

def escargotPythagore(n):
    angle=0
    long=50
    for i in range(n):
        setheading(0)
        left(angle)
        forward(long)
        left(90)
        forward(50)
        goto(0,0)
        angle=angle+degrees(atan(50/long))
        long=sqrt(long**2+50**2)
    exitonclick()
